<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../">
  <title data-ice="title">src/components/number/Number.unit.js | formiojs</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="JavaScript powered Forms with JSON Form Builder"><meta property="twitter:card" content="summary"><meta property="twitter:title" content="formiojs"><meta property="twitter:description" content="JavaScript powered Forms with JSON Form Builder"></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/atorico.com/formio/formio.js.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/EventEmitter.js~EventEmitter.html">EventEmitter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/Form.js~Form.html">Form</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/FormBuilder.js~FormBuilder.html">FormBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/PDFBuilder.js~PDFBuilder.html">PDFBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/WizardBuilder.js~WizardBuilder.html">WizardBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-embed">embed</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#builders">builders</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/builders/Builders.js~Builders.html">Builders</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components">components</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/Components.js~Components.html">Components</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component">components/_classes/component</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Component">Component</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component-editform">components/_classes/component/editForm</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-EditFormUtils">EditFormUtils</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-componentmodal">components/_classes/componentModal</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/componentModal/ComponentModal.js~ComponentModal.html">ComponentModal</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-field">components/_classes/field</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/field/Field.js~Field.html">Field</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-nested">components/_classes/nested</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/nested/NestedComponent.js~NestedComponent.html">NestedComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-NestedComponent">NestedComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-address">components/address</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Address">Address</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-button">components/button</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Button">Button</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-checkbox">components/checkbox</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/checkbox/Checkbox.js~CheckBoxComponent.html">CheckBoxComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Checkbox">Checkbox</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-columns">components/columns</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/columns/Columns.js~ColumnsComponent.html">ColumnsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Columns">Columns</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-container">components/container</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/container/Container.js~ContainerComponent.html">ContainerComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Container">Container</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-content">components/content</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/content/Content.js~ContentComponent.html">ContentComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Content">Content</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-currency">components/currency</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/currency/Currency.js~CurrencyComponent.html">CurrencyComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Currency">Currency</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datagrid">components/datagrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataGrid">DataGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datamap">components/datamap</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datamap/DataMap.js~DataMapComponent.html">DataMapComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataMap">DataMap</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datetime">components/datetime</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datetime/DateTime.js~DateTimeComponent.html">DateTimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DateTime">DateTime</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-day">components/day</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Day">Day</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-editgrid">components/editgrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditGrid">EditGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-email">components/email</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/email/Email.js~EmailComponent.html">EmailComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Email">Email</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-fieldset">components/fieldset</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/fieldset/Fieldset.js~FieldsetComponent.html">FieldsetComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Fieldset">Fieldset</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-file">components/file</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-File">File</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-form">components/form</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Form">Form</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-hidden">components/hidden</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/hidden/Hidden.js~HiddenComponent.html">HiddenComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Hidden">Hidden</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-html">components/html</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/html/HTML.js~HTMLComponent.html">HTMLComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-HTML">HTML</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-number">components/number</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/number/Number.js~NumberComponent.html">NumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Number">Number</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-panel">components/panel</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Panel">Panel</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-password">components/password</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/password/Password.js~PasswordComponent.html">PasswordComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Password">Password</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-phonenumber">components/phonenumber</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/phonenumber/PhoneNumber.js~PhoneNumberComponent.html">PhoneNumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-PhoneNumber">PhoneNumber</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-radio">components/radio</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/radio/Radio.js~RadioComponent.html">RadioComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Radio">Radio</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-recaptcha">components/recaptcha</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/recaptcha/ReCaptcha.js~ReCaptchaComponent.html">ReCaptchaComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ReCaptcha">ReCaptcha</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-resource">components/resource</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/resource/Resource.js~ResourceComponent.html">ResourceComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Resource">Resource</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select">components/select</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Select">Select</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select-fixtures">components/select/fixtures</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelect">multiSelect</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelectOptions">multiSelectOptions</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-selectboxes">components/selectboxes</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-SelectBoxes">SelectBoxes</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-signature">components/signature</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/signature/Signature.js~SignatureComponent.html">SignatureComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Signature">Signature</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-survey">components/survey</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Survey">Survey</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-table">components/table</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/table/Table.js~TableComponent.html">TableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Table">Table</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tabs">components/tabs</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tabs/Tabs.js~TabsComponent.html">TabsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tabs">Tabs</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tags">components/tags</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tags/Tags.js~TagsComponent.html">TagsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tags">Tags</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textarea">components/textarea</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextArea">TextArea</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textfield">components/textfield</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextField">TextField</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-time">components/time</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/time/Time.js~TimeComponent.html">TimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Time">Time</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tree">components/tree</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tree/Node.js~Node.html">Node</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tree">Tree</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-unknown">components/unknown</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/unknown/Unknown.js~UnknownComponent.html">UnknownComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Unknown">Unknown</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-url">components/url</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/url/Url.js~UrlComponent.html">UrlComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Url">Url</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-well">components/well</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/well/Well.js~WellComponent.html">WellComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Well">Well</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib">contrib</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Contrib">Contrib</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-edittable">contrib/edittable</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/edittable/EditTable.js~EditTableComponent.html">EditTableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditTable">EditTable</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-location">contrib/location</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/location/Location.js~LocationComponent.html">LocationComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Location">Location</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-modaledit">contrib/modaledit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/modaledit/ModalEdit.js~ModalEditComponent.html">ModalEditComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ModalEdit">ModalEdit</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-checkout">contrib/stripe/checkout</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/checkout/StripeCheckout.js~StripeCheckoutComponent.html">StripeCheckoutComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-stripe">contrib/stripe/stripe</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/stripe/Stripe.js~StripeComponent.html">StripeComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#displays">displays</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/displays/Displays.js~Displays.html">Displays</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers">providers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/Providers.js~Providers.html">Providers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-address">providers/address</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AddressProvider.js~AddressProvider.html">AddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AzureAddressProvider.js~AzureAddressProvider.html">AzureAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/CustomAddressProvider.js~CustomAddressProvider.html">CustomAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/NominatimAddressProvider.js~NominatimAddressProvider.html">NominatimAddressProvider</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-processor">providers/processor</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-fileProcessor">fileProcessor</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-storage">providers/storage</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-azure">azure</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-base64">base64</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-dropbox">dropbox</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-indexeddb">indexeddb</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-s3">s3</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getFormioUploadAdapterPlugin">getFormioUploadAdapterPlugin</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-url">url</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-setXhrHeaders">setXhrHeaders</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-XHR">XHR</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates">templates</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/templates/Templates.js~Templates.html">Templates</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates-bootstrap">templates/bootstrap</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-iconClass">iconClass</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils">utils</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/utils/ChoicesWrapper.js~ChoicesWrapper.html">ChoicesWrapper</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-checkInvalidDate">checkInvalidDate</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-lessOrGreater">lessOrGreater</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-applyFormChanges">applyFormChanges</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-eachComponent">eachComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-escapeRegExCharacters">escapeRegExCharacters</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponent">findComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponents">findComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-flattenComponents">flattenComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-formatAsCurrency">formatAsCurrency</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-generateFormChange">generateFormChange</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getComponent">getComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getStrings">getStrings</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getValue">getValue</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-hasCondition">hasCondition</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-isLayoutComponent">isLayoutComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-matchComponent">matchComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-parseFloatExt">parseFloatExt</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-removeComponent">removeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-searchComponents">searchComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-KEY_CODES">KEY_CODES</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Evaluator">Evaluator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CALENDAR_ERROR_MESSAGES">CALENDAR_ERROR_MESSAGES</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils-jsonlogic">utils/jsonlogic</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-lodashOperators">lodashOperators</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#validator">validator</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Rules.js~Rules.html">Rules</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Validator.js~ValidationChecker.html">ValidationChecker</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#widgets">widgets</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/widgets/InputWidget.js~InputWidget.html">InputWidget</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/components/number/Number.unit.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import assert from &apos;power-assert&apos;;
import _ from &apos;lodash&apos;;
import _merge from &apos;lodash/merge&apos;;
import Harness from &apos;../../../test/harness&apos;;
import Formio from &apos;./../../Formio&apos;;
import NumberComponent from &apos;./Number&apos;;

import {
  comp1,
  comp2,
  comp3,
  comp4,
  comp5,
  comp6
} from &apos;./fixtures&apos;;

describe(&apos;Number Component&apos;, () =&gt; {
  it(&apos;Should build an number component&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp1).then((component) =&gt; {
      Harness.testElements(component, &apos;input[type=&quot;text&quot;]&apos;, 1);
    });
  });

  it(&apos;Should format submissions for table view for French locale&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp4, { language: &apos;fr&apos; }).then((component) =&gt; {
      const value1 = component.getValueAsString(1);
      const value2 = component.getValueAsString(1.1);
      const value3 = component.getValueAsString(1.11);
      const value4 = component.getValueAsString(1111);
      const value5 = component.getValueAsString(1111111);
      const value6 = component.getValueAsString(-11111);

      assert.equal(value1, &apos;1,00&apos;);
      assert.equal(value2, &apos;1,10&apos;);
      assert.equal(value3, &apos;1,11&apos;);
      assert.equal(value4, &apos;1&#x202F;111,00&apos;);
      assert.equal(value5, &apos;1&#x202F;111&#x202F;111,00&apos;);
      assert.equal(value6, &apos;-11&#x202F;111,00&apos;);
    });
  });

  it(&apos;Should format sumbissions for table view for USA locale&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp4, { language: &apos;en-US&apos; }).then((component) =&gt; {
      const value1 = component.getValueAsString(1);
      const value2 = component.getValueAsString(1.1);
      const value3 = component.getValueAsString(1.11);
      const value4 = component.getValueAsString(1111);
      const value5 = component.getValueAsString(1111111);
      const value6 = component.getValueAsString(-11111);

      assert.equal(value1, &apos;1.00&apos;);
      assert.equal(value2, &apos;1.10&apos;);
      assert.equal(value3, &apos;1.11&apos;);
      assert.equal(value4, &apos;1,111.00&apos;);
      assert.equal(value5, &apos;1,111,111.00&apos;);
      assert.equal(value6, &apos;-11,111.00&apos;);
    });
  });

  it(&apos;Should format value on blur for USA locale&apos;, () =&gt; {
   return Harness.testCreate(NumberComponent, comp4, { language: &apos;en-US&apos; }).then((component) =&gt; {
      component.root = {
        onChange: ()=&gt;{},
        triggerChange: ()=&gt;{},
      };

      const blurEvent = new Event(&apos;blur&apos;);
      const inputEvent = new Event(&apos;input&apos;);
      const valueElement = component.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;);

      valueElement.value = 22222222;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.equal(valueElement.value, &apos;22,222,222.00&apos;);

      valueElement.value = 22222222.2;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.equal(valueElement.value, &apos;22,222,222.20&apos;);

      valueElement.value = 22222;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.equal(valueElement.value, &apos;22,222.00&apos;);

      valueElement.value = 2;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.equal(valueElement.value, &apos;2.00&apos;);
    });
  });

  it(&apos;Should format value on blur for French locale&apos;, (done) =&gt; {
    Harness.testCreate(NumberComponent, comp4, { language: &apos;fr&apos; }).then((component) =&gt; {
      component.root = {
        onChange: ()=&gt;{},
        triggerChange: ()=&gt;{},
      };

      const blurEvent = new Event(&apos;blur&apos;);
      const inputEvent = new Event(&apos;input&apos;);
      const valueElement = component.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;);

      valueElement.value = 22222222;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.deepEqual(valueElement.value, &apos;22&#x202F;222&#x202F;222,00&apos;);

      valueElement.value = &apos;22222222,2&apos;;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.deepEqual(valueElement.value, &apos;22&#x202F;222&#x202F;222,20&apos;);

      valueElement.value = 22222;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.deepEqual(valueElement.value, &apos;22&#x202F;222,00&apos;);

      valueElement.value = 222;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.deepEqual(valueElement.value, &apos;222,00&apos;);

      valueElement.value = 2;
      valueElement.dispatchEvent(inputEvent);
      valueElement.dispatchEvent(blurEvent);
      assert.deepEqual(valueElement.value, &apos;2,00&apos;);

      done();
    });
  });

  it(&apos;Should not change entered value on blur if multiple value is set&apos;, (done) =&gt; {
    Harness.testCreate(NumberComponent, comp5).then((component) =&gt; {
      component.root = {
        onChange: ()=&gt;{},
        triggerChange: ()=&gt;{},
      };
      const blurEvent = new Event(&apos;blur&apos;);
      const clickEvent = new Event(&apos;click&apos;);
      const addBtn = component.refs.addButton[0];

      addBtn.dispatchEvent(clickEvent);

      const firstValueElement = component.element.querySelectorAll(&apos;[name=&quot;data[number]&quot;]&apos;)[0];
      const secondValueElement = component.element.querySelectorAll(&apos;[name=&quot;data[number]&quot;]&apos;)[1];

      component.setValue([111,222]);

      firstValueElement.dispatchEvent(blurEvent);
      secondValueElement.dispatchEvent(blurEvent);

      assert.equal(component.dataValue[0], component.getValue()[0]);
      assert.equal(component.dataValue[1], component.getValue()[1]);
      done();
    });
  });

  it(&apos;Should limit decimals using step&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, _merge({}, comp2, {
      validate: {
        step: &apos;0.001&apos;
      }
    })).then((component) =&gt; {
      Harness.testSetInput(component, 123456789.123456789, 123456789.123, &apos;123,456,789.123&apos;);
      Harness.testSetInput(component, -123456789.123456789, -123456789.123, &apos;-123,456,789.123&apos;);
      Harness.testSetInput(component, &apos;123456789.123456789&apos;, 123456789.123, &apos;123,456,789.123&apos;);
      Harness.testSetInput(component, &apos;-123456789.123456789&apos;, -123456789.123, &apos;-123,456,789.123&apos;);
    });
  });

  it(&apos;Should format submissions for table view for French locale&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp2, { language: &apos;fr&apos; }).then((component) =&gt; {
      const value1 = component.getValueAsString(1);
      const value2 = component.getValueAsString(1.1);
      const value3 = component.getValueAsString(1.1111111);
      const value4 = component.getValueAsString(1111);
      const value5 = component.getValueAsString(1111111);
      const value6 = component.getValueAsString(-11111.1111);

      assert.equal(value1, &apos;1&apos;);
      assert.equal(value2, &apos;1,1&apos;);
      assert.equal(value3, &apos;1,1111111&apos;);
      assert.equal(value4, &apos;1&#x202F;111&apos;);
      assert.equal(value5, &apos;1&#x202F;111&#x202F;111&apos;);
      assert.equal(value6, &apos;-11&#x202F;111,1111&apos;);
    });
  });

  it(&apos;Should format sumissions for table view for USA locale&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp2, { language: &apos;en-US&apos; }).then((component) =&gt; {
      const value1 = component.getValueAsString(1);
      const value2 = component.getValueAsString(1.1);
      const value3 = component.getValueAsString(1.1111111);
      const value4 = component.getValueAsString(1111);
      const value5 = component.getValueAsString(1111111);
      const value6 = component.getValueAsString(-11111.1111);

      assert.equal(value1, &apos;1&apos;);
      assert.equal(value2, &apos;1.1&apos;);
      assert.equal(value3, &apos;1.1111111&apos;);
      assert.equal(value4, &apos;1,111&apos;);
      assert.equal(value5, &apos;1,111,111&apos;);
      assert.equal(value6, &apos;-11,111.1111&apos;);
    });
  });

  it(&apos;Should format numbers for USA locale&apos;, () =&gt; {
    /* eslint-disable max-statements */
    return Harness.testCreate(NumberComponent, comp2, { language: &apos;en-US&apos; }).then((component) =&gt; {
      Harness.testSetInput(component, null, null, &apos;&apos;);
      Harness.testSetInput(component, undefined, null, &apos;&apos;);
      Harness.testSetInput(component, &apos;&apos;, null, &apos;&apos;);
      Harness.testSetInput(component, {}, null, &apos;&apos;);
      Harness.testSetInput(component, [], null, &apos;&apos;);
      Harness.testSetInput(component, [&apos;&apos;], null, &apos;&apos;);
      Harness.testSetInput(component, [&apos;1&apos;], 1, &apos;1&apos;);
      Harness.testSetInput(component, 0, 0, &apos;0&apos;);
      Harness.testSetInput(component, 1, 1, &apos;1&apos;);
      Harness.testSetInput(component, -1, -1, &apos;-1&apos;);
      Harness.testSetInput(component, 1000, 1000, &apos;1,000&apos;);
      Harness.testSetInput(component, -1000, -1000, &apos;-1,000&apos;);
      Harness.testSetInput(component, 1000.00, 1000, &apos;1,000&apos;);
      Harness.testSetInput(component, -1000.00, -1000, &apos;-1,000&apos;);
      Harness.testSetInput(component, 1000.01, 1000.01, &apos;1,000.01&apos;);
      Harness.testSetInput(component, -1000.01, -1000.01, &apos;-1,000.01&apos;);
      Harness.testSetInput(component, 1000.001, 1000.001, &apos;1,000.001&apos;);
      Harness.testSetInput(component, -1000.001, -1000.001, &apos;-1,000.001&apos;);
      Harness.testSetInput(component, 1234567890.12, 1234567890.12, &apos;1,234,567,890.12&apos;);
      Harness.testSetInput(component, -1234567890.12, -1234567890.12, &apos;-1,234,567,890.12&apos;);
      Harness.testSetInput(component, 12.123456789, 12.123456789, &apos;12.123456789&apos;);
      Harness.testSetInput(component, -12.123456789, -12.123456789, &apos;-12.123456789&apos;);
      // These tests run into the maximum number of significant digits for floats.
      Harness.testSetInput(component, 123456789.123456789, 123456789.123456789, &apos;123,456,789.12345679&apos;);
      Harness.testSetInput(component, -123456789.123456789, -123456789.123456789, &apos;-123,456,789.12345679&apos;);
      Harness.testSetInput(component, &apos;0&apos;, 0, &apos;0&apos;);
      Harness.testSetInput(component, &apos;1&apos;, 1, &apos;1&apos;);
      Harness.testSetInput(component, &apos;-1&apos;, -1, &apos;-1&apos;);
      Harness.testSetInput(component, &apos;1000&apos;, 1000, &apos;1,000&apos;);
      Harness.testSetInput(component, &apos;-1000&apos;, -1000, &apos;-1,000&apos;);
      Harness.testSetInput(component, &apos;1000.01&apos;, 1000.01, &apos;1,000.01&apos;);
      Harness.testSetInput(component, &apos;-1000.01&apos;, -1000.01, &apos;-1,000.01&apos;);
      Harness.testSetInput(component, &apos;1000.00&apos;, 1000, &apos;1,000&apos;);
      Harness.testSetInput(component, &apos;-1000.00&apos;, -1000, &apos;-1,000&apos;);
      Harness.testSetInput(component, &apos;1000.001&apos;, 1000.001, &apos;1,000.001&apos;);
      Harness.testSetInput(component, &apos;-1000.001&apos;, -1000.001, &apos;-1,000.001&apos;);
      Harness.testSetInput(component, &apos;1234567890.12&apos;, 1234567890.12, &apos;1,234,567,890.12&apos;);
      Harness.testSetInput(component, &apos;-1234567890.12&apos;, -1234567890.12, &apos;-1,234,567,890.12&apos;);
      Harness.testSetInput(component, &apos;12.123456789&apos;, 12.123456789, &apos;12.123456789&apos;);
      Harness.testSetInput(component, &apos;-12.123456789&apos;, -12.123456789, &apos;-12.123456789&apos;);
      Harness.testSetInput(component, &apos;123456789.123456789&apos;, 123456789.123456789, &apos;123,456,789.12345679&apos;);
      Harness.testSetInput(component, &apos;-123456789.123456789&apos;, -123456789.123456789, &apos;-123,456,789.12345679&apos;);
    });
    /* eslint-enable max-statements */
  });

  it(&apos;Should format numbers for British locale&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp2, { language: &apos;en-GB&apos; }).then((component) =&gt; {
      Harness.testSetInput(component, null, null, &apos;&apos;);
      Harness.testSetInput(component, 0, 0, &apos;0&apos;);
      Harness.testSetInput(component, 1, 1, &apos;1&apos;);
      Harness.testSetInput(component, -1, -1, &apos;-1&apos;);
      Harness.testSetInput(component, 1000, 1000, &apos;1,000&apos;);
      Harness.testSetInput(component, -1000, -1000, &apos;-1,000&apos;);
      Harness.testSetInput(component, 1000.00, 1000, &apos;1,000&apos;);
      Harness.testSetInput(component, -1000.00, -1000, &apos;-1,000&apos;);
      Harness.testSetInput(component, 1000.01, 1000.01, &apos;1,000.01&apos;);
      Harness.testSetInput(component, -1000.01, -1000.01, &apos;-1,000.01&apos;);
      Harness.testSetInput(component, 1000.001, 1000.001, &apos;1,000.001&apos;);
      Harness.testSetInput(component, -1000.001, -1000.001, &apos;-1,000.001&apos;);
      Harness.testSetInput(component, 1234567890.12, 1234567890.12, &apos;1,234,567,890.12&apos;);
      Harness.testSetInput(component, -1234567890.12, -1234567890.12, &apos;-1,234,567,890.12&apos;);
      Harness.testSetInput(component, 12.123456789, 12.123456789, &apos;12.123456789&apos;);
      Harness.testSetInput(component, -12.123456789, -12.123456789, &apos;-12.123456789&apos;);
    });
  });

  it(&apos;Should format numbers for French locale&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp2, { language: &apos;fr&apos; }).then((component) =&gt; {
      // The spaces in these tests are a weird unicode space so be careful duplicating the tests.
      Harness.testSetInput(component, null, null, &apos;&apos;);
      Harness.testSetInput(component, 0, 0, &apos;0&apos;);
      Harness.testSetInput(component, 1, 1, &apos;1&apos;);
      Harness.testSetInput(component, -1, -1, &apos;-1&apos;);
      Harness.testSetInput(component, 1000, 1000, &apos;1&#x202F;000&apos;);
      Harness.testSetInput(component, -1000, -1000, &apos;-1&#x202F;000&apos;);
      Harness.testSetInput(component, 1000.00, 1000, &apos;1&#x202F;000&apos;);
      Harness.testSetInput(component, -1000.00, -1000, &apos;-1&#x202F;000&apos;);
      Harness.testSetInput(component, 1000.01, 1000.01, &apos;1&#x202F;000,01&apos;);
      Harness.testSetInput(component, -1000.01, -1000.01, &apos;-1&#x202F;000,01&apos;);
      Harness.testSetInput(component, 1000.001, 1000.001, &apos;1&#x202F;000,001&apos;);
      Harness.testSetInput(component, -1000.001, -1000.001, &apos;-1&#x202F;000,001&apos;);
      Harness.testSetInput(component, 1234567890.12, 1234567890.12, &apos;1&#x202F;234&#x202F;567&#x202F;890,12&apos;);
      Harness.testSetInput(component, -1234567890.12, -1234567890.12, &apos;-1&#x202F;234&#x202F;567&#x202F;890,12&apos;);
      Harness.testSetInput(component, 12.123456789, 12.123456789, &apos;12,123456789&apos;);
      Harness.testSetInput(component, -12.123456789, -12.123456789, &apos;-12,123456789&apos;);
    });
  });

  it(&apos;Should format numbers for German locale&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp2, { language: &apos;de&apos; }).then((component) =&gt; {
      Harness.testSetInput(component, null, null, &apos;&apos;);
      Harness.testSetInput(component, 0, 0, &apos;0&apos;);
      Harness.testSetInput(component, 1, 1, &apos;1&apos;);
      Harness.testSetInput(component, -1, -1, &apos;-1&apos;);
      Harness.testSetInput(component, 1000, 1000, &apos;1.000&apos;);
      Harness.testSetInput(component, -1000, -1000, &apos;-1.000&apos;);
      Harness.testSetInput(component, 1000.00, 1000, &apos;1.000&apos;);
      Harness.testSetInput(component, -1000.00, -1000, &apos;-1.000&apos;);
      Harness.testSetInput(component, 1000.01, 1000.01, &apos;1.000,01&apos;);
      Harness.testSetInput(component, -1000.01, -1000.01, &apos;-1.000,01&apos;);
      Harness.testSetInput(component, 1000.001, 1000.001, &apos;1.000,001&apos;);
      Harness.testSetInput(component, -1000.001, -1000.001, &apos;-1.000,001&apos;);
      Harness.testSetInput(component, 1234567890.12, 1234567890.12, &apos;1.234.567.890,12&apos;);
      Harness.testSetInput(component, -1234567890.12, -1234567890.12, &apos;-1.234.567.890,12&apos;);
      Harness.testSetInput(component, 12.123456789, 12.123456789, &apos;12,123456789&apos;);
      Harness.testSetInput(component, -12.123456789, -12.123456789, &apos;-12,123456789&apos;);
    });
  });

  it(&apos;Should display default integer value&apos;, () =&gt; {
    return Harness.testCreate(NumberComponent, comp3).then(number =&gt; {
      assert.deepEqual(_.get(number, [&apos;refs&apos;, &apos;input&apos;, &apos;0&apos;, &apos;value&apos;]), &apos;42&apos;);
    });
  });

  it(&apos;Should display default decimal value&apos;, () =&gt; {
    const TEST_VAL = 4.2;
    const comp = _.cloneDeep(comp3);

    comp.defaultValue = TEST_VAL;
    comp.decimalLimit = 2;
    comp.requireDecimal = true;

    return Harness.testCreate(NumberComponent, comp).then(number =&gt; {
      assert.deepEqual(_.get(number, [&apos;refs&apos;, &apos;input&apos;, &apos;0&apos;, &apos;value&apos;]), &apos;4.20&apos;);
    });
  });

  it(&apos;Should provide min/max validation&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp6);

    const validValues = [
      null,
      20,
      555,
      34,
      20.000001,
      554.999
    ];

    const invalidMin = [
      19.99,
      0,
      1,
      0.34,
      -0.1,
      -20
    ];

    const invalidMax = [
      555.00000001,
      100000,
      5555,
    ];

    const testValidity = (values, valid, message, lastValue) =&gt; {
      _.each(values, (value) =&gt; {
        const element = document.createElement(&apos;div&apos;);

        Formio.createForm(element, form, { language: &apos;en-US&apos; }).then(form =&gt; {
          form.setPristine(false);

          const component = form.getComponent(&apos;number&apos;);
          const changed = component.setValue(value);
          const error = message;

          if (value) {
            assert.equal(changed, true, &apos;Should set value&apos;);
          }

          setTimeout(() =&gt; {
            if (valid) {
              assert.equal(!!component.error, false, &apos;Should not contain error&apos;);
            }
            else {
              assert.equal(!!component.error, true, &apos;Should contain error&apos;);
              assert.equal(component.error.message, error, &apos;Should contain error message&apos;);
              assert.equal(component.element.classList.contains(&apos;has-error&apos;), true, &apos;Should contain error class&apos;);
              assert.equal(component.refs.messageContainer.textContent.trim(), error, &apos;Should show error&apos;);
            }

            if (_.isEqual(value, lastValue)) {
              done();
            }
          }, 300);
        }).catch(done);
      });
    };

    testValidity(validValues, true);
    testValidity(invalidMin, false, &apos;Number cannot be less than 20.&apos;);
    testValidity(invalidMax, false, &apos;Number cannot be greater than 555.&apos;, invalidMax[invalidMax.length-1]);
  });

  // it(&apos;Should add trailing zeros on blur, if decimal required&apos;, (done) =&gt; {
  //   const comp = _.cloneDeep(comp3);
  //
  //   comp.decimalLimit = 2;
  //   comp.requireDecimal = true;
  //
  //   Harness.testCreate(NumberComponent, comp).then(number =&gt; {
  //     const testset = [
  //       // [inv, outv, display]
  //       [&apos;42&apos;,        42,       &apos;42.00&apos;],
  //       [&apos;42.1&apos;,      42.1,     &apos;42.10&apos;],
  //       [&apos;42.01&apos;,     42.01,    &apos;42.01&apos;],
  //       [&apos;4200&apos;,      4200,     &apos;4200.00&apos;],
  //       [&apos;4200.4&apos;,    4200.4,   &apos;4200.40&apos;],
  //       [&apos;4200.42&apos;,   4200.42,  &apos;4200.42&apos;],
  //       [&apos;4200.&apos;,     4200,     &apos;4200.00&apos;],
  //       [&apos;99999999.&apos;, 99999999, &apos;99999999.00&apos;]
  //     ];
  //
  //     testset.forEach((set, index) =&gt; {
  //       try {
  //         Harness.testNumberBlur(number, ...set);
  //       }
  //       catch (err) {
  //         done(new Error(`Test case #${index}, set: ${set}, err: ${err.message}`));
  //       }
  //     });
  //
  //     done();
  //   }, done);
  // });
  //
  // it(&apos;Should add trailing zeros on blur, if decimal and delimiter is required&apos;, (done) =&gt; {
  //   const comp = _.cloneDeep(comp3);
  //
  //   comp.decimalLimit = 2;
  //   comp.requireDecimal = true;
  //   comp.delimiter = true;
  //
  //   /* eslint-disable max-statements */
  //   Harness.testCreate(NumberComponent, comp).then(number =&gt; {
  //     const testset = [
  //       // [inv, outv, display]
  //       [&apos;42&apos;,        42,       &apos;42.00&apos;],
  //       [&apos;42.1&apos;,      42.1,     &apos;42.10&apos;],
  //       [&apos;42.01&apos;,     42.01,    &apos;42.01&apos;],
  //       [&apos;4200&apos;,      4200,     &apos;4,200.00&apos;],
  //       [&apos;4200.4&apos;,    4200.4,   &apos;4,200.40&apos;],
  //       [&apos;4200.42&apos;,   4200.42,  &apos;4,200.42&apos;],
  //       [&apos;4200.&apos;,     4200,     &apos;4,200.00&apos;],
  //       [&apos;99999999.&apos;, 99999999, &apos;99,999,999.00&apos;]
  //     ];
  //
  //     testset.forEach((set, index) =&gt; {
  //       try {
  //         Harness.testNumberBlur(number, ...set);
  //       }
  //       catch (err) {
  //         done(new Error(`Test case #${index}, set: ${set}, err: ${err.message}`));
  //       }
  //     });
  //
  //     done();
  //   }, done);
  // });
  //
  // it(&apos;Should add trailing zeros on blur with `multiple` flag&apos;, (done) =&gt; {
  //   Harness.testCreate(NumberComponent, comp4).then(number =&gt; {
  //     const testset = [
  //       [&apos;42&apos;,        42,       &apos;42.00&apos;],
  //       [&apos;42.1&apos;,      42.1,     &apos;42.10&apos;],
  //       [&apos;42.01&apos;,     42.01,    &apos;42.01&apos;],
  //       [&apos;4200&apos;,      4200,     &apos;4,200.00&apos;],
  //       [&apos;4200.4&apos;,    4200.4,   &apos;4,200.40&apos;],
  //       [&apos;4200.42&apos;,   4200.42,  &apos;4,200.42&apos;],
  //       [&apos;4200.&apos;,     4200,     &apos;4,200.00&apos;],
  //       [&apos;99999999.&apos;, 99999999, &apos;99,999,999.00&apos;]
  //     ];
  //
  //     testset.forEach((set, index) =&gt; {
  //       try {
  //         assert.strictEqual(number.inputs.length, index + 1);
  //         Harness.testNumberBlur(number, ...set, index);
  //         number.addValue();
  //       }
  //       catch (err) {
  //         done(new Error(`Test case #${index}, set: ${set}, err: ${err.message}`));
  //       }
  //     });
  //
  //     done();
  //   }, done);
  // });
});
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
